<?php

declare(strict_types=1);

namespace mirzaev\vk\robot\bobby\programs;

// Фреймворк ВКонтакте
use mirzaev\vk\robots\robot;

// Модуль чат-робота для фреймворка ВКонтакте
use mirzaev\vk\chat\core,
    mirzaev\vk\chat\program;

/**
 * Программа: "конвертер упоминаний"
 *
 * Принцип работы:
 *
 * 1. Пользователь отправляет: "@id123456789 (Имя)"
 * 2. Сервер получает: "[id123456789|Имя]"
 * 3. Программа конвертирует: "[id123456789|Имя]" в "@id123456789 (Имя)"
 *
 * Это нужно для того, чтобы упоминание понял препроцессор ВКонтакте
 *
 * @package mirzaev\vk\robot\bobby\programs
 * @author Arsen Mirzaev Tatyano-Muradovich <arsen@mirzaev.sexy>
 */
class mentions_converter extends program
{
    /**
     * Конструктор
     *
     * @param robot $robot Робот, который будет выполнять команду
     * @param array $accounts Реестр аккаунтов которым разрешено выполнять команду
     */
    public function __construct(
        public robot $robot,
        public array $accounts = []
    ) {
        parent::__construct(function (core $core, robot $robot, array &$update): void {
            // Конвертация упоминаний
            $update['object']['message']['text'] = preg_replace_callback('/(*UTF8)(?=[^\[]+)[^\[]+|\[(id\d+)\|([^\]]+)\]/', fn (array $matches) => isset($matches[2]) ? '@' . $matches[1] . ' (' . $matches[2] . ')' : $matches[0] ?? $update['object']['message']['text'], $update['object']['message']['text'], 500);
        }, $robot, $accounts);
    }
}
